function resIm = segImage(im,clusters,countClusters)

countClusters = min(countClusters,max(clusters(:)));
maskIm = zeros([size(im,1) size(im,2)]);
deriv = [1 -1];
for c=1:countClusters,
   tmp = zeros(size(maskIm));
   tmp(clusters == c) = 1;
   dx = conv2(tmp,deriv,'same');
   dy = conv2(tmp,deriv','same');
   maskIm = maskIm + abs(dx)+abs(dy);
end
maskIm(maskIm>1)=1;
resIm = im;
if (size(im,3)==1)
    resIm(:,:)=max(maskIm,im);
    return
end
for i=1:3,
  resIm(:,:,i)=max(maskIm,im(:,:,i));
end

